precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;

uniform float uProgress;// result:(0 ~ 1)
uniform int uType;//

const float smoothness = 1.0;//
const float PI = 3.141592653589;

vec4 animate (vec2 uv);

void main() {
    gl_FragColor = animate(vTextureCoord);
}

vec4 animate (vec2 uv) {
    vec4 textureColor = texture2D(sTexture, uv);
    vec2 rp = uv*2.-1.;
    float alpha = smoothstep(0., smoothness,  atan(-rp.x, rp.y) - (uProgress-.5) * PI * 2.5);
    if (uType == 0){
        alpha = 1.- alpha;
    }
    return vec4(textureColor.rgb, alpha * textureColor.a);
}
