precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D sTextureAlpha;

uniform float uProgress;// result:(0 ~ 1)

vec4 animate (vec2 uv);

void main() {
    gl_FragColor = animate(vTextureCoord);
}

vec4 animate (vec2 uv) {
    vec4 textureColor = texture2D(sTexture, uv);
    vec4 alphaColor = texture2D(sTextureAlpha, uv);
    float count = mod(floor(alphaColor.a * 255.), 3.) + 3.;
    float progress = uProgress * count - floor(uProgress * count);
    progress = abs(cos(radians(progress * 180.)));
    float alpha = (1.0 - alphaColor.a) * progress + alphaColor.a;
//    float alpha = (1.0 - alphaColor.a) * uProgress + alphaColor.a;
    return vec4(textureColor.rgb, alpha * textureColor.a);
}
