precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;

uniform float uProgress;// result:(0 ~ 1)
const float smoothness = 1.0;// = 0.3
uniform int type;// 0: opening other: closeing
vec4 animate (vec2 uv);

void main() {
    gl_FragColor = animate(vTextureCoord);
}

vec4 animate (vec2 uv) {
    vec4 textureColor = texture2D(sTexture, uv);
    vec2 center = vec2(0.5, uv.y);
    float d =  distance(center, uv);
    if (type != 0){
        d = 0.5 - d;
    }
    float alpha = smoothstep(0.0, smoothness, uProgress*(1.+smoothness)-2.*d);
    if (type != 0){
        alpha = 1. - alpha;
    }
    return vec4(textureColor.rgb, alpha * textureColor.a);
}
