precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D sTextureShowTime;

uniform float uProgress;// result:(0 ~ 1)

vec4 animate (vec2 uv);

void main() {
    gl_FragColor = animate(vTextureCoord);
}

vec4 animate (vec2 uv) {
    vec4 textureColor = texture2D(sTexture, uv);
    vec4 showTimeColor = texture2D(sTextureShowTime, uv);
    float alpha = 1.0 - step(uProgress, showTimeColor.a);
    return vec4(textureColor.rgb, alpha * textureColor.a);
}
