precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;

uniform float uProgress;// result:(0 ~ 1)
uniform int direction; // 0:left 1:right 2:up 3:down

vec4 animate (vec2 uv);

void main() {
    gl_FragColor = animate(vTextureCoord);
}

vec4 animate (vec2 uv) {
    vec4 textureColor = texture2D(sTexture, uv);
    vec2 p = uv.xy / vec2(1.0).xy;
    float alpha;
    if (direction == 0) {
        alpha = step(1.0 - p.x, uProgress);
    } else if (direction == 1) {
        alpha = step(0.0 + p.x, uProgress);
    } else if (direction == 2) {
        alpha = step(1.0 - p.y, uProgress);
    } else {
        alpha = step(0.0 + p.y, uProgress);
    }
    return vec4(textureColor.rgb, alpha * textureColor.a);
}
