precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const vec4 fromStep = vec4(0.0, 0.2, 0.4, 0.0);
const vec4 toStep = vec4(0.6, 0.8, 1.0, 1.0);

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition (vec2 uv) {
    vec4 a = getFromColor(uv);
    vec4 b = getToColor(uv);
    return mix(a, b, smoothstep(fromStep, toStep, vec4(uProgress)));
}

