precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const vec2 center = vec2(0.5); // = vec2(0.5)
const float threshold = 3.0; // = 3.0
const float fadeEdge = 0.1; // = 0.1

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

float rand(vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}
vec4 transition(vec2 p) {
    float dist = distance(center, p) / threshold;
    float r = uProgress - min(rand(vec2(p.y, 0.0)), rand(vec2(0.0, p.x)));
    return mix(getFromColor(p), getToColor(p), mix(0.0, mix(step(dist, r), 1.0, smoothstep(1.0-fadeEdge, 1.0, uProgress)), smoothstep(0.0, fadeEdge, uProgress)));
}

