precision mediump float;
const vec2 direction = vec2(0.0, 1.0);

varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition (in vec2 uv) {
    vec2 p = uv + uProgress * sign(direction);
    vec2 f = fract(p);
    return mix(
               getToColor(f),
               getFromColor(f),
               step(0.0, p.y) * step(p.y, 1.0) * step(0.0, p.x) * step(p.x, 1.0)
               );
}
