precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const float size = 0.04;
const float zoom = 50.0;
const float colorSeparation = 0.3;

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition(vec2 p) {
    float inv = 1. - uProgress;
    vec2 disp = size*vec2(cos(zoom*p.x), sin(zoom*p.y));
    vec4 texTo = getToColor(p + inv*disp);
    vec4 texFrom = vec4(
                        getFromColor(p + uProgress*disp*(1.0 - colorSeparation)).r,
                        getFromColor(p + uProgress*disp).g,
                        getFromColor(p + uProgress*disp*(1.0 + colorSeparation)).b,
                        1.0);
    return texTo*uProgress + texFrom*inv;
}

