precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition(vec2 p) {
    vec2 block = floor(p.xy / vec2(16));
    vec2 uv_noise = block / vec2(64);
    uv_noise += floor(vec2(uProgress) * vec2(1200.0, 3500.0)) / vec2(64);
    vec2 dist = uProgress > 0.0 ? (fract(uv_noise) - 0.5) * 0.3 *(1.0 -uProgress) : vec2(0.0);
    vec2 red = p + dist * 0.2;
    vec2 green = p + dist * .3;
    vec2 blue = p + dist * .5;
    
    return vec4(mix(getFromColor(red), getToColor(red), uProgress).r,mix(getFromColor(green), getToColor(green), uProgress).g,mix(getFromColor(blue), getToColor(blue), uProgress).b,1.0);
}

