precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const float smoothness = 1.0; //

const float PI = 3.141592653589;

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition(vec2 p) {
    vec2 rp = p*2.-1.;
    return mix(
               getToColor(p),
               getFromColor(p),
               smoothstep(0., smoothness, atan(rp.y,rp.x) - (uProgress-.5) * PI * 2.5)
               );
}

