precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const float amplitude = 100.0; //
const float speed = 50.0; //

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition (vec2 uv) {
    vec2 dir = uv - vec2(.5);
    float dist = length(dir);
    vec2 offset = dir * (sin(uProgress * dist * amplitude - uProgress * speed) + .5) / 30.;
    return mix(
               getFromColor(uv + offset),
               getToColor(uv),
               smoothstep(0.2, 1.0, uProgress)
               );
}

