precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const float amplitude = 30.0;
const float speed = 30.0;

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition(vec2 p) {
    vec2 dir = p - vec2(.5);
    float dist = length(dir);
    
    if (dist > uProgress) {
        return mix(getFromColor( p), getToColor( p), uProgress);
    } else {
        vec2 offset = dir * sin(dist * amplitude - uProgress * speed);
        return mix(getFromColor( p + offset), getToColor( p), uProgress);
    }
}
