precision mediump float;
varying vec2 vTextureCoord;

uniform sampler2D sTexture;
uniform sampler2D uTexture_1;

uniform float uProgress;// result:(0 ~ 1)

const float count = 10.0;
const float smoothness = 0.5;

vec4 transition (vec2 uv);

void main() {
    gl_FragColor = transition(vTextureCoord);
}

vec4 getFromColor(in vec2 uv){
    return texture2D(sTexture, uv);
}

vec4 getToColor(in vec2 uv){
    return texture2D(uTexture_1, uv);
}

vec4 transition (vec2 p) {
    float pr = smoothstep(-smoothness, 0.0, p.x - uProgress * (1.0 + smoothness));
    float s = step(pr, fract(count * p.x));
    return mix(getFromColor(p), getToColor(p), s);
}
